using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace Raison2
{
    public class Synthetiseur : INotifyPropertyChanged, IEquatable<Synthetiseur>
    {
        public Synthetiseur()
        { }

        public Synthetiseur(string nom, string fabriquant, int notation, string imageUrl)
        {
            this.nom = nom;
            this.fabriquant = fabriquant;
            this.notation = notation;
            this.imageUrl = imageUrl;
        }

        private string nom;

        public string Nom
        {
            get { return nom; }
            set
            {
                nom = value;
                FirePropertyChanged("Nom");
            }
        }

        private string fabriquant;

        public string Fabriquant
        {
            get { return fabriquant; }
            set
            {
                fabriquant = value;
                FirePropertyChanged("Fabriquant");
            }
        }

        private int notation;

        public int Notation
        {
            get { return notation; }
            set
            {
                notation = value;
                FirePropertyChanged("Notation");
            }

        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void FirePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, 
                    new PropertyChangedEventArgs(propertyName));
        }

        public override string ToString()
        {
            return nom;
        }

        private string imageUrl;

        public string ImageUrl
        {
            get
            {
                return imageUrl;
            }
            set
            {
                imageUrl = value;
                FirePropertyChanged("ImageUrl");
            }
        }

        public bool Equals(Synthetiseur obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            return Equals(obj.nom, nom) && Equals(obj.fabriquant, fabriquant) && obj.notation == notation && Equals(obj.imageUrl, imageUrl);
        }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != typeof (Synthetiseur)) return false;
            return Equals((Synthetiseur) obj);
        }

        public override int GetHashCode()
        {
            unchecked
            {
                int result = (nom != null ? nom.GetHashCode() : 0);
                result = (result*397) ^ (fabriquant != null ? fabriquant.GetHashCode() : 0);
                result = (result*397) ^ notation;
                result = (result*397) ^ (imageUrl != null ? imageUrl.GetHashCode() : 0);
                return result;
            }
        }

        public static bool operator ==(Synthetiseur left, Synthetiseur right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(Synthetiseur left, Synthetiseur right)
        {
            return !Equals(left, right);
        }
    }
}
